package com.app.plugincpuinfo;

import androidx.annotation.NonNull;
import android.app.ActivityManager;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import android.content.Context;
import java.io.IOException;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
/** PlugincpuinfoPlugin */
public class PlugincpuinfoPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private Context applicationContext;
  ProcessBuilder processBuilder;
    
  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
     this.applicationContext = flutterPluginBinding.getApplicationContext();
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "plugincpuinfo");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else if (call.method.equals("getMemorySpace")) {
            long res = (getTotalRam()/(1024 * 1024));
            
            result.success(""+res);
    } else if (call.method.equals("getCPUUsage")) {
            String res =getCpuUsages();
            
            result.success(""+res);
    } else {
      result.notImplemented();
    }
  }

  public String getCpuUsages()
  {
     String output = "";  
    try {
                String[] DATA = {"/system/bin/cat", "/proc/cpuinfo"};
                ProcessBuilder processBuilder = new ProcessBuilder(DATA);
                Process process = null;
               
                    process = processBuilder.start();
                
                InputStream inputStream = process.getInputStream();
                byte[] byteArry = new byte[1024];
               
                while (inputStream.read(byteArry) != -1) {
                    output = output + new String(byteArry);
                }
                inputStream.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
   return output; 
}
  private long getTotalRam() {
        ActivityManager actManager = (ActivityManager) applicationContext.getSystemService(Context.ACTIVITY_SERVICE);
        ActivityManager.MemoryInfo memInfo = new ActivityManager.MemoryInfo();
        assert actManager != null;
        actManager.getMemoryInfo(memInfo);
        return memInfo.totalMem;
    }
  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
     applicationContext = null;
    channel.setMethodCallHandler(null);
  }
}
